from datetime import datetime

import pytz


class StaticDataProvider:
    """Generic static reference data provider class. Subclasses of this query the individual URLs or files for data."""

    def __init__(self, name, provider_config):
        """Constructor"""

        self.name = name
        self.enabled = provider_config["enabled"]
        self.last_update_time = datetime.min.replace(tzinfo=pytz.UTC)
        self.status = "Not Started" if self.enabled else "Disabled"
        self.reference_count = 0


    def start(self):
        """Start the provider. This should return immediately after spawning threads to access the remote resources"""

        raise NotImplementedError("Subclasses must implement this method")


    def stop(self):
        """Stop any threads and prepare for application shutdown"""

        raise NotImplementedError("Subclasses must implement this method")
